
//
// To jest przykładowy kod z podrozdziału 18.6.3 „Wykorzystanie wskaźników” książki
// "Programowanie. Teoria i praktyka z wykorzystaniem C++" Bjarne'a Stroustrupa.
//

#include "std_lib_facilities.h"

//------------------------------------------------------------------------------

bool is_palindrome(const char* first, const char* last)
// Wskaźnik first wskazuje pierwszą literę, last — ostatnią.
{
    if (first<last) {
        if (*first!=*last) return false;
        return is_palindrome(++first,--last);
    }
    return true;
}

//------------------------------------------------------------------------------

istream& read_word(istream& is, char* buffer, int max)
// Wczytuje najwyżej max–1 znaków z is do bufora.
{
    is.width(max);         // Wczytuje najwyżej max–1 znaków w znajdującym się dalej >>.
    is >> buffer;          // Wczytuje zakończone spacją słowo,
    // i dodaje zero za ostatnim znakiem wczytanym do p.
    return is;
}

//------------------------------------------------------------------------------

int main()
{
    const int max = 128;
    char s[max];
    while (read_word(cin,s,max)) { 
        cout << s << " is";
        if (!is_palindrome(s,strlen(s))) cout << " nie";
        cout << " jest palindromem.\n";
    }
}

//------------------------------------------------------------------------------
